{  This file is part of Gum_Mc, uncertainty calculation software
    Copyright (C) 2010  Jean-Marie Biansan
        Contact: jeanmarie.biansan@free.fr
    Web site: http://jeanmarie.biansan.free.fr/logiciel.html
 Gum_Mc is distribued under the terms of the
 GNU General Public License.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA}



unit Unit_saisie_proprietes_dune_grandeur;

{$mode objfpc}

interface

uses
  UChaines,Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, ExtCtrls, Buttons,LCLType,SpecFunx,Unit_genere_distribution,MonBitmap,Math
  ,UnitScaleFont,Unit_aidecalcul;

type

  { Tsaisie_dune_grandeur }

  Tsaisie_dune_grandeur = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    ComboBox1: TComboBox;
    Edit_inc_inc: TEdit;
    Edit_degre: TEdit;
    Edit_arcsin_moyenne: TEdit;
    Edit_rectangulaire_demi_etendue: TEdit;
    Edit_trapeze_demi_etendue_bas: TEdit;
    Edit_trapeze_demi_etendue_haut: TEdit;
    Edit_trapeze_incertitude_type: TEdit;
    Edit_arcsin_incertitude_type: TEdit;
    Edit_triangulaire_demi_etendue: TEdit;
    Edit_rectangulaire_incertitude_type: TEdit;
    Edit_arcsin_demi_etendue: TEdit;
    Edit_triangulaire_incertitude_type: TEdit;
    Edit_rectangulaire_moyenne: TEdit;
    Edit_triangulaire_moyenne: TEdit;
    Edit_student_pourcentage: TEdit;
    Edit_student_incertitude_elargie: TEdit;
    Edit_student_ecart_type_moyenne: TEdit;
    Edit_student_ecart_type_echantionnal: TEdit;
    Edit_student_moyenne: TEdit;
    Edit_normale_pourcentage: TEdit;
    Edit_normale_incertitude_elargie: TEdit;
    Edit_student_nombre_degre_de_liberte: TEdit;
    Edit_normale_incertitude_type: TEdit;
    Edit_normale_moyenne: TEdit;
    Edit_trapeze_moyenne: TEdit;
    ImageListexplication: TImageList;
    Image_explication: TImage;
    Label1: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label2: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label3: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Panel2: TPanel;
    Panel_degre: TPanel;
    Panel_AB: TPanel;
    Panel_arcsinus: TPanel;
    Panel_trapeze: TPanel;
    Panel_triangulaire: TPanel;
    Panel_rectangulaire: TPanel;
    Panel_normale: TPanel;
    Panel_student: TPanel;
    RadioButton_inc_inc: TRadioButton;
    RadioButton_degre: TRadioButton;
    RadioButton_type_B: TRadioButton;
    RadioButton_type_A: TRadioButton;
    RadioButton_rectangulaire_demi_etendue: TRadioButton;
    RadioButton_triangulaire_demi_etendue: TRadioButton;
    RadioButton_rectangulaire_incertitude_type: TRadioButton;
    RadioButton_triangulaire_incertitude_type: TRadioButton;
    RadioButton_student_incertitude_elargie: TRadioButton;
    RadioButton_student_ecart_type_moyenne: TRadioButton;
    RadioButton_student_ecart_type_echantionnal: TRadioButton;
    RadioButton_normale_incertitude_type: TRadioButton;
    RadioButton_normale_incertitude_elargie: TRadioButton;
    SpeedButton1: TSpeedButton;
    StaticText1: TStaticText;
    procedure BitBtn1Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
       procedure RadioButton_degreChange(Sender: TObject);
    procedure RadioButton_inc_incChange(Sender: TObject);
    procedure RadioButton_normale_incertitude_elargieChange(Sender: TObject);
    procedure RadioButton_normale_incertitude_typeChange(Sender: TObject);
    procedure RadioButton_rectangulaire_demi_etendueChange(Sender: TObject);
    procedure RadioButton_rectangulaire_incertitude_typeChange(Sender: TObject);
    procedure RadioButton_student_ecart_type_echantionnalChange(Sender: TObject
      );
    procedure RadioButton_student_ecart_type_moyenneChange(Sender: TObject);
    procedure RadioButton_student_incertitude_elargieChange(Sender: TObject);
    procedure RadioButton_triangulaire_demi_etendueChange(Sender: TObject);
    procedure RadioButton_triangulaire_incertitude_typeChange(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);

  private      encreation:boolean;
    { private declarations }
  public
    { public declarations }
  end; 

var
  saisie_dune_grandeur: Tsaisie_dune_grandeur;
   mc:tmonbitmap;  nb_points_traces:longint;
    policetitre,policegraduation:tfont;
    bornes,densites:extendedarray;
effectifs:longintarray;    eff_max:longint; densite_max:extended;
  liste_student_a_ete_modifiee:boolean;
implementation
 uses Unit1,Unit_trace;
{ Tsaisie_dune_grandeur }




procedure Tsaisie_dune_grandeur.BitBtn1Click(Sender: TObject);
var r:extended;   i:integer;  kkk:longint;  bmp : tbitmap;
label 314;
begin
  tous_calculs_faits:=false;

   policetitre:=tfont.Create;
     policetitre.Assign(form1.Font);
      policetitre.Style:=[fsbold,fsunderline];
      policetitre.Size:=12;
      policetitre.Color:=clblue;






     policegraduation:=tfont.Create;
      policegraduation.Assign(form1.font);
      policegraduation.Size:=10;
       policegraduation.Color:=clblue;
       if radiobutton_type_A.Checked then liste_distributions[indice_distribution-1].tyAB:=type_A else
       liste_distributions[indice_distribution-1].tyAB:=type_B;





 {distrib de type student}
 if combobox1.ItemIndex=0 then begin
 liste_distributions[indice_distribution-1].tyty:=d_student;
 if liste_student_a_ete_modifiee then  liste_mesurandes[indice_mesurande].estimateur:=_moyenne;

  liste_distributions[indice_distribution-1].nom_variable:=saisie_dune_grandeur.Edit_student_moyenne.text;


  try
  i:=strtoint(saisie_dune_grandeur.Edit_student_nombre_degre_de_liberte.text);
  except
    application.messagebox(pchar(rsValeurDuNomb), pchar(rsAttention2), mb_ok);
    self.ModalResult:=mrnone;
    exit;
    end;
  if i<1 then begin
  application.messagebox(pchar(rsValeurDuNomb), pchar(rsAttention2), mb_ok);
  self.ModalResult:=mrnone;
    exit;
    end;
  liste_distributions[indice_distribution-1].degres_de_liberte:=i;
   liste_distributions[indice_distribution-1].degres_de_liberte_effectif:=
          liste_distributions[indice_distribution-1].degres_de_liberte;

  if radiobutton_student_ecart_type_echantionnal.Checked then begin
  try
  r:=strtofloat(saisie_dune_grandeur.Edit_student_ecart_type_echantionnal.text);
  except
    application.messagebox(pchar(rsValeurDeLCar), pchar(rsAttention2), mb_ok);
    self.ModalResult:=mrnone;
    exit;
    end;

  if r=0 then begin
  application.messagebox(pchar(rsValeurDeLCar2), pchar(rsAttention2), mb_ok);
    self.ModalResult:=mrnone;
    exit;
    end;

  liste_distributions[indice_distribution-1].ecart_type_echantionnal:=abs(r);
  liste_distributions[indice_distribution-1].incertitude_type:=r/sqrt(1+liste_distributions[indice_distribution-1].degres_de_liberte);
  liste_distributions[indice_distribution-1].pourcentage:=95;
  liste_distributions[indice_distribution-1].incertitude_elargie:=liste_distributions[indice_distribution-1].incertitude_type*
  abs(t_invx(liste_distributions[indice_distribution-1].degres_de_liberte,(1-0.95)/2));
  liste_distributions[indice_distribution-1].defini_par:=par_ecart_type_echantionnal;
  if saisie_mesures_effectuee then begin
  liste_distributions[indice_distribution-1].student_nombre_mesures:=_nombre_mesures;
  setlength(liste_distributions[indice_distribution-1].student_liste_mesures,_nombre_mesures);
  for i:=1 to _nombre_mesures do
  liste_distributions[indice_distribution-1].student_liste_mesures[i-1]:=_liste_mesures_correctes[i-1];
  end else
  begin
  liste_distributions[indice_distribution-1].student_nombre_mesures:=0;
  setlength(liste_distributions[indice_distribution-1].student_liste_mesures,_nombre_mesures);
  end;



  end;

   if radiobutton_student_ecart_type_moyenne.Checked then begin
  try
  r:=strtofloat(saisie_dune_grandeur.Edit_student_ecart_type_moyenne.text);
  except
    application.messagebox(pchar(rsValeurDeLCar3), pchar(rsAttention2), mb_ok);
    self.ModalResult:=mrnone;
    exit;
    end;
   if r=0 then begin
  application.messagebox(pchar(rsValeurDeLCar4), pchar(rsAttention2), mb_ok);
    self.ModalResult:=mrnone;
    exit;
    end;

  liste_distributions[indice_distribution-1].incertitude_type:=abs(r);
  liste_distributions[indice_distribution-1].ecart_type_echantionnal:=r*sqrt(1+liste_distributions[indice_distribution-1].degres_de_liberte);
  liste_distributions[indice_distribution-1].pourcentage:=95;
  liste_distributions[indice_distribution-1].incertitude_elargie:=liste_distributions[indice_distribution-1].incertitude_type*
  abs(t_invx(liste_distributions[indice_distribution-1].degres_de_liberte,(1-0.95)/2));
  liste_distributions[indice_distribution-1].defini_par:=par_incertitude_type;
 end;

   if radiobutton_student_incertitude_elargie.Checked then begin
  try
  r:=strtofloat(saisie_dune_grandeur.Edit_student_incertitude_elargie.text);
  except
    application.messagebox(pchar(rsValeurDeLInc), pchar(rsAttention2), mb_ok);
    self.ModalResult:=mrnone;
    exit;
    end;
   if r=0 then begin
  application.messagebox(pchar(rsValeurDeLInc2), pchar(rsAttention2), mb_ok);
    self.ModalResult:=mrnone;
    exit;
    end;
  liste_distributions[indice_distribution-1].incertitude_elargie:=abs(r);
   try
  r:=strtofloat(saisie_dune_grandeur.Edit_student_pourcentage.text);
  except
    application.messagebox(pchar(rsValeurDuPour), pchar(rsAttention2), mb_ok);
    self.ModalResult:=mrnone;
    exit;
    end;
 if ((r>=100) or (r<=0)) then begin
 application.messagebox(pchar(rsValeurDuPour), pchar(
   rsAttention2), mb_ok);
 self.ModalResult:=mrnone;
    exit;
    end;
  liste_distributions[indice_distribution-1].pourcentage:=r;
  liste_distributions[indice_distribution-1].incertitude_type:=liste_distributions[indice_distribution-1].incertitude_elargie/
  abs(t_invx(liste_distributions[indice_distribution-1].degres_de_liberte,(1-liste_distributions[indice_distribution-1].pourcentage/100)/2));
  liste_distributions[indice_distribution-1].ecart_type_echantionnal:=liste_distributions[indice_distribution-1].incertitude_type*sqrt(1+liste_distributions[indice_distribution-1].degres_de_liberte);


  liste_distributions[indice_distribution-1].defini_par:=par_incertitude_elargie;
 end;
   screen.Cursor:=crhourglass;
 Genere_Student(liste_echantillons_entree[indice_distribution-1],nombre_par_echantillon,  liste_distributions[indice_distribution-1].moyenne,
 liste_distributions[indice_distribution-1].ecart_type_echantionnal, liste_distributions[indice_distribution-1].degres_de_liberte);
 Copie_Distribution(liste_echantillons_entree[indice_distribution-1],copie_liste_echantillons_entree[indice_distribution-1],nombre_par_echantillon);
 Tri_Rapide(liste_echantillons_entree[indice_distribution-1],nombre_par_echantillon);
 Decale_Doublons(liste_echantillons_entree[indice_distribution-1],nombre_par_echantillon);
  mc.LimitesEtAxes(@liste_images_integre[indice_distribution-1],liste_echantillons_entree[indice_distribution-1][0],liste_echantillons_entree[indice_distribution-1][nombre_par_echantillon-1],0
         ,1,0,1,liste_images_integre[indice_distribution-1].width,
liste_images_integre[indice_distribution-1].Height, rsFonctionDeDi, policetitre, true,
  clwhite, true, 1, clblack,
true,1,4,clblue,policegraduation, true,false,1,clblue,
clblack,'x','f(x)','','','','',
false ,true,false);
  nb_points_traces:=200;
 for kkk:=0 to nb_points_traces do begin
 mc.croixx(liste_echantillons_entree[indice_distribution-1][0]+(liste_echantillons_entree[indice_distribution-1][nombre_par_echantillon-1]-liste_echantillons_entree[indice_distribution-1][0])*kkk/nb_points_traces,
 Fonction_Distribution(liste_echantillons_entree[indice_distribution-1],nombre_par_echantillon,liste_echantillons_entree[indice_distribution-1][0]+
 (liste_echantillons_entree[indice_distribution-1][nombre_par_echantillon-1]-liste_echantillons_entree[indice_distribution-1][0])*kkk/nb_points_traces),
 2,1,clblue,pmcopy,true);
 mc.croixx(liste_echantillons_entree[indice_distribution-1][0]+(liste_echantillons_entree[indice_distribution-1][nombre_par_echantillon-1]-liste_echantillons_entree[indice_distribution-1][0])*kkk/nb_points_traces,
 student_integree(liste_distributions[indice_distribution-1].moyenne,liste_distributions[indice_distribution-1].ecart_type_echantionnal,
 liste_distributions[indice_distribution-1].degres_de_liberte,liste_echantillons_entree[indice_distribution-1][0]+
 (liste_echantillons_entree[indice_distribution-1][nombre_par_echantillon-1]-liste_echantillons_entree[indice_distribution-1][0])*kkk/nb_points_traces),
 2,1,clred,pmcopy,true);
    end;

 Statistiques_Par_Classe(liste_echantillons_entree[indice_distribution-1],nombre_par_echantillon,nombre_de_classes,
 bornes,effectifs,densites,eff_max,densite_max);


 mc.LimitesEtAxes(@liste_images_densite[indice_distribution-1],bornes[0],bornes[nombre_de_classes],0
         ,densite_max,0,densite_max,liste_images_densite[indice_distribution-1].width,
liste_images_densite[indice_distribution-1].Height, rsDensitDeProb, policetitre, true,
  clwhite, true, 1, clblack,
true,1,4,clblue,policegraduation, true,false,1,clblue,
clblack,'x','f(x)','','','','',
false ,true,false);
 for kkk:=1 to nombre_de_classes do
 mc.MonRectangle(bornes[kkk-1],0,bornes[kkk],densites[kkk-1],clblue,true);
 for kkk:=0 to nb_points_traces do
 mc.croixx(liste_echantillons_entree[indice_distribution-1][0]+(liste_echantillons_entree[indice_distribution-1][nombre_par_echantillon-1]-liste_echantillons_entree[indice_distribution-1][0])*kkk/nb_points_traces,
 student_densite(liste_distributions[indice_distribution-1].moyenne,liste_distributions[indice_distribution-1].ecart_type_echantionnal,
 liste_distributions[indice_distribution-1].degres_de_liberte,liste_echantillons_entree[indice_distribution-1][0]+
 (liste_echantillons_entree[indice_distribution-1][nombre_par_echantillon-1]-liste_echantillons_entree[indice_distribution-1][0])*kkk/nb_points_traces),
 2,1,clred,pmcopy,true);

 goto 314;
 end;
    {fin distrib de type student}

   begin

         if radiobutton_inc_inc.Checked then
          begin
          try
          strtofloat(edit_inc_inc.Text);
          except
          application.messagebox(pchar(rsValeurDeLInc3), pchar(rsAttention2),
            mb_ok);
    self.ModalResult:=mrnone;
    exit;
            end; {du except}

          if  abs(strtofloat(edit_inc_inc.Text))>=100 then begin
           application.messagebox(pchar(rsValeurDeLInc4), pchar(rsAttention2),
             mb_ok);
    self.ModalResult:=mrnone;
    exit;
            end; {de >100%}
       liste_distributions[indice_distribution-1].inc_rel_sur_inc:=abs(strtofloat(edit_inc_inc.Text)/100);
       if  liste_distributions[indice_distribution-1].inc_rel_sur_inc>0 then
          liste_distributions[indice_distribution-1].degres_de_liberte_effectif:=1/2/sqr(liste_distributions[indice_distribution-1].inc_rel_sur_inc)
          else liste_distributions[indice_distribution-1].degres_de_liberte_effectif:=NAN;

          end; {du cas radio inc checked}

   if radiobutton_degre.Checked then
          begin
          try
          strtofloat(edit_degre.Text);
          except
          application.messagebox(pchar(rsValeurDuDegr), pchar(rsAttention2),
            mb_ok);
    self.ModalResult:=mrnone;
    exit;
            end; {du except}

          if  abs(strtofloat(edit_degre.Text))<0.5 then begin
           application.messagebox(pchar(rsValeurDuDegr2), pchar(rsAttention2),
             mb_ok);
    self.ModalResult:=mrnone;
    exit;
            end; {de <1/2}
       liste_distributions[indice_distribution-1].degres_de_liberte_effectif:=abs(strtofloat(edit_degre.Text));

          liste_distributions[indice_distribution-1].inc_rel_sur_inc:=1/sqrt(2*liste_distributions[indice_distribution-1].degres_de_liberte_effectif);


          end; {du cas radio degre checked}

       end;{du cas non student}


     {distrib de type normale}
 if combobox1.ItemIndex=1 then begin
 liste_distributions[indice_distribution-1].tyty:=d_normale;



  liste_distributions[indice_distribution-1].nom_variable:=saisie_dune_grandeur.Edit_normale_moyenne.text;
   liste_distributions[indice_distribution-1].moyenne:=0;



   if radiobutton_normale_incertitude_type.Checked then begin
  try
  r:=strtofloat(saisie_dune_grandeur.Edit_normale_incertitude_type.text);
  except
    application.messagebox(pchar(rsValeurDeLInc5), pchar(rsAttention2), mb_ok);
    self.ModalResult:=mrnone;
    exit;
    end;
  if r=0 then begin
  application.messagebox(pchar(rsValeurDeLInc6), pchar(
    rsAttention2), mb_ok);
    self.ModalResult:=mrnone;
    exit;
    end;
  liste_distributions[indice_distribution-1].incertitude_type:=abs(r);
  liste_distributions[indice_distribution-1].pourcentage:=95;
  liste_distributions[indice_distribution-1].incertitude_elargie:=liste_distributions[indice_distribution-1].incertitude_type*
  abs(normstd_invx((1-0.95)/2));
  liste_distributions[indice_distribution-1].defini_par:=par_incertitude_type;
 end;

   if radiobutton_normale_incertitude_elargie.Checked then begin
  try
  r:=strtofloat(saisie_dune_grandeur.Edit_normale_incertitude_elargie.text);
  except
    application.messagebox(pchar(rsValeurDeLInc7), pchar(rsAttention2), mb_ok);
    self.ModalResult:=mrnone;
    exit;
    end;
  if r=0 then begin
  application.messagebox(pchar(rsValeurDeLInc8),
    pchar(rsAttention2), mb_ok);
    self.ModalResult:=mrnone;
    exit;
    end;
  liste_distributions[indice_distribution-1].incertitude_elargie:=abs(r);
   try
  r:=strtofloat(saisie_dune_grandeur.Edit_normale_pourcentage.text);
  except
    application.messagebox(pchar(rsValeurDuPour), pchar(rsAttention2), mb_ok);
    self.ModalResult:=mrnone;
    exit;
    end;
 if ((r>=100) or (r<=0)) then begin
 application.messagebox(pchar(rsValeurDuPour), pchar(
   rsAttention2), mb_ok);
 self.ModalResult:=mrnone;
    exit;
    end;
  liste_distributions[indice_distribution-1].pourcentage:=r;
  liste_distributions[indice_distribution-1].incertitude_type:=liste_distributions[indice_distribution-1].incertitude_elargie/
  abs(normstd_invx((1-liste_distributions[indice_distribution-1].pourcentage/100)/2));
  liste_distributions[indice_distribution-1].defini_par:=par_incertitude_elargie;
 end;

      screen.Cursor:=crhourglass;
    Genere_Normale(liste_echantillons_entree[indice_distribution-1],nombre_par_echantillon,  liste_distributions[indice_distribution-1].moyenne,
 liste_distributions[indice_distribution-1].incertitude_type);
    Copie_Distribution(liste_echantillons_entree[indice_distribution-1],copie_liste_echantillons_entree[indice_distribution-1],nombre_par_echantillon);
 Tri_Rapide(liste_echantillons_entree[indice_distribution-1],nombre_par_echantillon);
 Decale_Doublons(liste_echantillons_entree[indice_distribution-1],nombre_par_echantillon);
  mc.LimitesEtAxes(@liste_images_integre[indice_distribution-1],liste_echantillons_entree[indice_distribution-1][0],liste_echantillons_entree[indice_distribution-1][nombre_par_echantillon-1],0
         ,1,0,1,liste_images_integre[indice_distribution-1].width,
liste_images_integre[indice_distribution-1].Height, rsFonctionDeDi, policetitre, true,
  clwhite, true, 1, clblack,
true,1,4,clblue,policegraduation, true,false,1,clblue,
clblack,'x','f(x)','','','','',
false ,true,false);
  nb_points_traces:=200;
 for kkk:=0 to nb_points_traces do begin
 mc.croixx(liste_echantillons_entree[indice_distribution-1][0]+(liste_echantillons_entree[indice_distribution-1][nombre_par_echantillon-1]-liste_echantillons_entree[indice_distribution-1][0])*kkk/nb_points_traces,
 Fonction_Distribution(liste_echantillons_entree[indice_distribution-1],nombre_par_echantillon,liste_echantillons_entree[indice_distribution-1][0]+
 (liste_echantillons_entree[indice_distribution-1][nombre_par_echantillon-1]-liste_echantillons_entree[indice_distribution-1][0])*kkk/nb_points_traces),
 2,1,clblue,pmcopy,true);
 mc.croixx(liste_echantillons_entree[indice_distribution-1][0]+(liste_echantillons_entree[indice_distribution-1][nombre_par_echantillon-1]-liste_echantillons_entree[indice_distribution-1][0])*kkk/nb_points_traces,
 Normale_integree(liste_distributions[indice_distribution-1].moyenne,liste_distributions[indice_distribution-1].incertitude_type,
 liste_echantillons_entree[indice_distribution-1][0]+
 (liste_echantillons_entree[indice_distribution-1][nombre_par_echantillon-1]-liste_echantillons_entree[indice_distribution-1][0])*kkk/nb_points_traces),
 2,1,clred,pmcopy,true);
    end;

 Statistiques_Par_Classe(liste_echantillons_entree[indice_distribution-1],nombre_par_echantillon,nombre_de_classes,
 bornes,effectifs,densites,eff_max,densite_max);


 mc.LimitesEtAxes(@liste_images_densite[indice_distribution-1],bornes[0],bornes[nombre_de_classes],0
         ,densite_max,0,densite_max,liste_images_densite[indice_distribution-1].width,
liste_images_densite[indice_distribution-1].Height, rsDensitDeProb, policetitre, true,
  clwhite, true, 1, clblack,
true,1,4,clblue,policegraduation, true,false,1,clblue,
clblack,'x','f(x)','','','','',
false ,true,false);
 for kkk:=1 to nombre_de_classes do
 mc.MonRectangle(bornes[kkk-1],0,bornes[kkk],densites[kkk-1],clblue,true);
 for kkk:=0 to nb_points_traces do
 mc.croixx(liste_echantillons_entree[indice_distribution-1][0]+(liste_echantillons_entree[indice_distribution-1][nombre_par_echantillon-1]-liste_echantillons_entree[indice_distribution-1][0])*kkk/nb_points_traces,
 Normale_densite(liste_distributions[indice_distribution-1].moyenne,liste_distributions[indice_distribution-1].incertitude_type,
 liste_echantillons_entree[indice_distribution-1][0]+
 (liste_echantillons_entree[indice_distribution-1][nombre_par_echantillon-1]-liste_echantillons_entree[indice_distribution-1][0])*kkk/nb_points_traces),
 2,1,clred,pmcopy,true);
   end;
    {fin distrib de type normale}




    {distrib de type rectangulaire}
 if saisie_dune_grandeur.combobox1.ItemIndex=2 then begin
 liste_distributions[indice_distribution-1].tyty:=d_rectangle;



  liste_distributions[indice_distribution-1].nom_variable:=saisie_dune_grandeur.Edit_rectangulaire_moyenne.text;
   liste_distributions[indice_distribution-1].moyenne:=0;




   if radiobutton_rectangulaire_incertitude_type.Checked then begin
  try
  r:=strtofloat(saisie_dune_grandeur.Edit_rectangulaire_incertitude_type.text);
  except
    application.messagebox(pchar(rsValeurDeLInc9),
      pchar(rsAttention2), mb_ok);
    self.ModalResult:=mrnone;
    exit;
    end;
  if r=0 then begin
  application.messagebox(pchar(rsValeurDeLInc10), pchar(rsAttention2), mb_ok);
    self.ModalResult:=mrnone;
    exit;
    end;
  liste_distributions[indice_distribution-1].incertitude_type:=abs(r);
  liste_distributions[indice_distribution-1].demi_etendue:=liste_distributions[indice_distribution-1].incertitude_type*sqrt(3);
  liste_distributions[indice_distribution-1].defini_par:=par_incertitude_type;
 end;

   if radiobutton_rectangulaire_demi_etendue.Checked then begin
  try
  r:=strtofloat(saisie_dune_grandeur.Edit_rectangulaire_demi_etendue.text);
  except
    application.messagebox(pchar(rsValeurDeLaDe), pchar
      (rsAttention2), mb_ok);
    self.ModalResult:=mrnone;
    exit;
    end;
  if r=0 then begin
  application.messagebox(pchar(rsValeurDeLInc11), pchar(rsAttention2), mb_ok);
    self.ModalResult:=mrnone;
    exit;
    end;
  liste_distributions[indice_distribution-1].demi_etendue:=abs(r);
  liste_distributions[indice_distribution-1].incertitude_type:=liste_distributions[indice_distribution-1].demi_etendue/sqrt(3);
  liste_distributions[indice_distribution-1].defini_par:=par_demi_etendue;
   end;

   screen.Cursor:=crhourglass;
  Genere_Rectangulaire(liste_echantillons_entree[indice_distribution-1],nombre_par_echantillon,  liste_distributions[indice_distribution-1].moyenne,
 liste_distributions[indice_distribution-1].demi_etendue);
  Copie_Distribution(liste_echantillons_entree[indice_distribution-1],copie_liste_echantillons_entree[indice_distribution-1],nombre_par_echantillon);
 Tri_Rapide(liste_echantillons_entree[indice_distribution-1],nombre_par_echantillon);
 Decale_Doublons(liste_echantillons_entree[indice_distribution-1],nombre_par_echantillon);



  mc.LimitesEtAxes(@liste_images_integre[indice_distribution-1],liste_echantillons_entree[indice_distribution-1][0],
  liste_echantillons_entree[indice_distribution-1][nombre_par_echantillon-1],0
         ,1,0,1,liste_images_integre[indice_distribution-1].width,
liste_images_integre[indice_distribution-1].Height, rsFonctionDeDi, policetitre, true,
  clwhite, true, 1, clblack,
true,1,4,clblue,policegraduation, true,false,1,clblue,
clblack,'x','f(x)','','','','',
false ,true,false);
  nb_points_traces:=200;
 for kkk:=0 to nb_points_traces do begin
 mc.croixx(liste_echantillons_entree[indice_distribution-1][0]+(liste_echantillons_entree[indice_distribution-1][nombre_par_echantillon-1]-liste_echantillons_entree[indice_distribution-1][0])*kkk/nb_points_traces,
 Fonction_Distribution(liste_echantillons_entree[indice_distribution-1],nombre_par_echantillon,liste_echantillons_entree[indice_distribution-1][0]+
 (liste_echantillons_entree[indice_distribution-1][nombre_par_echantillon-1]-liste_echantillons_entree[indice_distribution-1][0])*kkk/nb_points_traces),
 2,1,clblue,pmcopy,true);
 mc.croixx(liste_echantillons_entree[indice_distribution-1][0]+(liste_echantillons_entree[indice_distribution-1][nombre_par_echantillon-1]-liste_echantillons_entree[indice_distribution-1][0])*kkk/nb_points_traces,
 Rectangulaire_integree(liste_distributions[indice_distribution-1].moyenne,liste_distributions[indice_distribution-1].demi_etendue,
 liste_echantillons_entree[indice_distribution-1][0]+
 (liste_echantillons_entree[indice_distribution-1][nombre_par_echantillon-1]-liste_echantillons_entree[indice_distribution-1][0])*kkk/nb_points_traces),
 2,1,clred,pmcopy,true);
    end;

 Statistiques_Par_Classe(liste_echantillons_entree[indice_distribution-1],nombre_par_echantillon,nombre_de_classes,
 bornes,effectifs,densites,eff_max,densite_max);


 mc.LimitesEtAxes(@liste_images_densite[indice_distribution-1],bornes[0],bornes[nombre_de_classes],0
         ,densite_max,0,densite_max,liste_images_densite[indice_distribution-1].width,
liste_images_densite[indice_distribution-1].Height, rsDensitDeProb, policetitre, true,
  clwhite, true, 1, clblack,
true,1,4,clblue,policegraduation, true,false,1,clblue,
clblack,'x','f(x)','','','','',
false ,true,false);
 for kkk:=1 to nombre_de_classes do
 mc.MonRectangle(bornes[kkk-1],0,bornes[kkk],densites[kkk-1],clblue,true);
 for kkk:=0 to nb_points_traces do
 mc.croixx(liste_echantillons_entree[indice_distribution-1][0]+(liste_echantillons_entree[indice_distribution-1][nombre_par_echantillon-1]-liste_echantillons_entree[indice_distribution-1][0])*kkk/nb_points_traces,
 Rectangulaire_densite(liste_distributions[indice_distribution-1].moyenne,liste_distributions[indice_distribution-1].demi_etendue,
 liste_echantillons_entree[indice_distribution-1][0]+
 (liste_echantillons_entree[indice_distribution-1][nombre_par_echantillon-1]-liste_echantillons_entree[indice_distribution-1][0])*kkk/nb_points_traces),
 2,1,clred,pmcopy,true);

   end;
    {fin distrib de type rectangulaire}


    {distrib de type triangulaireangulaire}
 if combobox1.ItemIndex=3 then begin
 liste_distributions[indice_distribution-1].tyty:=d_triangle;


  liste_distributions[indice_distribution-1].nom_variable:=saisie_dune_grandeur.Edit_triangulaire_moyenne.text;
   liste_distributions[indice_distribution-1].moyenne:=0;





   if radiobutton_triangulaire_incertitude_type.Checked then begin
  try
  r:=strtofloat(saisie_dune_grandeur.Edit_triangulaire_incertitude_type.text);
  except
    application.messagebox(pchar(rsValeurDeLInc12),
      pchar(rsAttention2), mb_ok);
    self.ModalResult:=mrnone;
    exit;
    end;
  if r=0 then begin
  application.messagebox(pchar(rsValeurDeLInc13), pchar(rsAttention2), mb_ok);
    self.ModalResult:=mrnone;
    exit;
    end;
  liste_distributions[indice_distribution-1].incertitude_type:=abs(r);
  liste_distributions[indice_distribution-1].demi_etendue:=liste_distributions[indice_distribution-1].incertitude_type*sqrt(6);
  liste_distributions[indice_distribution-1].defini_par:=par_incertitude_type;
 end;

   if radiobutton_triangulaire_demi_etendue.Checked then begin
  try
  r:=strtofloat(saisie_dune_grandeur.Edit_triangulaire_demi_etendue.text);
  except
    application.messagebox(pchar(rsValeurDeLaDe), pchar
      (rsAttention2), mb_ok);
    self.ModalResult:=mrnone;
    exit;
    end;
  if r=0 then begin
  application.messagebox(pchar(rsValeurDeLInc14), pchar(rsAttention2), mb_ok);
    self.ModalResult:=mrnone;
    exit;
    end;
  liste_distributions[indice_distribution-1].demi_etendue:=abs(r);
  liste_distributions[indice_distribution-1].incertitude_type:=liste_distributions[indice_distribution-1].demi_etendue/sqrt(6);
  liste_distributions[indice_distribution-1].defini_par:=par_demi_etendue;
 end;

        screen.Cursor:=crhourglass;
    Genere_Triangulaire(liste_echantillons_entree[indice_distribution-1],nombre_par_echantillon,  liste_distributions[indice_distribution-1].moyenne,
 liste_distributions[indice_distribution-1].demi_etendue);
    Copie_Distribution(liste_echantillons_entree[indice_distribution-1],copie_liste_echantillons_entree[indice_distribution-1],nombre_par_echantillon);
 Tri_Rapide(liste_echantillons_entree[indice_distribution-1],nombre_par_echantillon);
 Decale_Doublons(liste_echantillons_entree[indice_distribution-1],nombre_par_echantillon);
  mc.LimitesEtAxes(@liste_images_integre[indice_distribution-1],liste_echantillons_entree[indice_distribution-1][0],liste_echantillons_entree[indice_distribution-1][nombre_par_echantillon-1],0
         ,1,0,1,liste_images_integre[indice_distribution-1].width,
liste_images_integre[indice_distribution-1].Height, rsFonctionDeDi, policetitre, true,
  clwhite, true, 1, clblack,
true,1,4,clblue,policegraduation, true,false,1,clblue,
clblack,'x','f(x)','','','','',
false ,true,false);
  nb_points_traces:=200;
 for kkk:=0 to nb_points_traces do begin
 mc.croixx(liste_echantillons_entree[indice_distribution-1][0]+(liste_echantillons_entree[indice_distribution-1][nombre_par_echantillon-1]-liste_echantillons_entree[indice_distribution-1][0])*kkk/nb_points_traces,
 Fonction_Distribution(liste_echantillons_entree[indice_distribution-1],nombre_par_echantillon,liste_echantillons_entree[indice_distribution-1][0]+
 (liste_echantillons_entree[indice_distribution-1][nombre_par_echantillon-1]-liste_echantillons_entree[indice_distribution-1][0])*kkk/nb_points_traces),
 2,1,clblue,pmcopy,true);
 mc.croixx(liste_echantillons_entree[indice_distribution-1][0]+(liste_echantillons_entree[indice_distribution-1][nombre_par_echantillon-1]-liste_echantillons_entree[indice_distribution-1][0])*kkk/nb_points_traces,
 Triangulaire_integree(liste_distributions[indice_distribution-1].moyenne,liste_distributions[indice_distribution-1].demi_etendue,
 liste_echantillons_entree[indice_distribution-1][0]+
 (liste_echantillons_entree[indice_distribution-1][nombre_par_echantillon-1]-liste_echantillons_entree[indice_distribution-1][0])*kkk/nb_points_traces),
 2,1,clred,pmcopy,true);
    end;

 Statistiques_Par_Classe(liste_echantillons_entree[indice_distribution-1],nombre_par_echantillon,nombre_de_classes,
 bornes,effectifs,densites,eff_max,densite_max);


 mc.LimitesEtAxes(@liste_images_densite[indice_distribution-1],bornes[0],bornes[nombre_de_classes],0
         ,densite_max,0,densite_max,liste_images_densite[indice_distribution-1].width,
liste_images_densite[indice_distribution-1].Height, rsDensitDeProb, policetitre, true,
  clwhite, true, 1, clblack,
true,1,4,clblue,policegraduation, true,false,1,clblue,
clblack,'x','f(x)','','','','',
false ,true,false);
 for kkk:=1 to nombre_de_classes do
 mc.MonRectangle(bornes[kkk-1],0,bornes[kkk],densites[kkk-1],clblue,true);
 for kkk:=0 to nb_points_traces do
 mc.croixx(liste_echantillons_entree[indice_distribution-1][0]+(liste_echantillons_entree[indice_distribution-1][nombre_par_echantillon-1]-liste_echantillons_entree[indice_distribution-1][0])*kkk/nb_points_traces,
 Triangulaire_densite(liste_distributions[indice_distribution-1].moyenne,liste_distributions[indice_distribution-1].demi_etendue,
 liste_echantillons_entree[indice_distribution-1][0]+
 (liste_echantillons_entree[indice_distribution-1][nombre_par_echantillon-1]-liste_echantillons_entree[indice_distribution-1][0])*kkk/nb_points_traces),
 2,1,clred,pmcopy,true);

   end;
    {fin distrib de type triangulaire}



     {distrib de type trapeze}
 if combobox1.ItemIndex=4 then begin
 liste_distributions[indice_distribution-1].tyty:=d_trapeze;



  liste_distributions[indice_distribution-1].nom_variable:=saisie_dune_grandeur.Edit_trapeze_moyenne.text;
   liste_distributions[indice_distribution-1].moyenne:=0;



 try
  r:=strtofloat(saisie_dune_grandeur.Edit_trapeze_demi_etendue_bas.text);
  except
    application.messagebox(pchar(rsValeurDeLaDe), pchar
      (rsAttention2), mb_ok);
    self.ModalResult:=mrnone;
    exit;
    end;
  if r=0 then begin
  application.messagebox(pchar(rsValeurDeLInc15), pchar(rsAttention2), mb_ok);
    self.ModalResult:=mrnone;
    exit;
    end;
  liste_distributions[indice_distribution-1].demi_etendue_bas:=abs(r);

  try
  r:=strtofloat(saisie_dune_grandeur.Edit_trapeze_demi_etendue_haut.text);
  except
    application.messagebox(pchar(rsValeurDeLaDe), pchar
      (rsAttention2), mb_ok);
    self.ModalResult:=mrnone;
    exit;
    end;
  if r=0 then begin
  application.messagebox(pchar(rsValeurDeLInc16), pchar(rsAttention2), mb_ok);
    self.ModalResult:=mrnone;
    exit;
    end;
  liste_distributions[indice_distribution-1].demi_etendue_haut:=abs(r);

 if liste_distributions[indice_distribution-1].demi_etendue_haut>=liste_distributions[indice_distribution-1].demi_etendue_bas
 then begin
 application.messagebox(pchar(rsDemiTendueHa), pchar(rsAttention2), mb_ok);
    self.ModalResult:=mrnone;
    exit;
    end;


  liste_distributions[indice_distribution-1].incertitude_type:=2*liste_distributions[indice_distribution-1].demi_etendue_bas/sqrt(24)*
  sqrt(1+sqr(liste_distributions[indice_distribution-1].demi_etendue_haut/liste_distributions[indice_distribution-1].demi_etendue_bas));
  saisie_dune_grandeur.Edit_trapeze_incertitude_type.Text:=floattostr(liste_distributions[indice_distribution-1].incertitude_type);

        screen.Cursor:=crhourglass;
   Genere_Trapeze(liste_echantillons_entree[indice_distribution-1],nombre_par_echantillon,  liste_distributions[indice_distribution-1].moyenne,
 liste_distributions[indice_distribution-1].demi_etendue_bas,liste_distributions[indice_distribution-1].demi_etendue_haut);
   Copie_Distribution(liste_echantillons_entree[indice_distribution-1],copie_liste_echantillons_entree[indice_distribution-1],nombre_par_echantillon);

 Tri_Rapide(liste_echantillons_entree[indice_distribution-1],nombre_par_echantillon);
 Decale_Doublons(liste_echantillons_entree[indice_distribution-1],nombre_par_echantillon);
  mc.LimitesEtAxes(@liste_images_integre[indice_distribution-1],liste_echantillons_entree[indice_distribution-1][0],liste_echantillons_entree[indice_distribution-1][nombre_par_echantillon-1],0
         ,1,0,1,liste_images_integre[indice_distribution-1].width,
liste_images_integre[indice_distribution-1].Height, rsFonctionDeDi, policetitre, true,
  clwhite, true, 1, clblack,
true,1,4,clblue,policegraduation, true,false,1,clblue,
clblack,'x','f(x)','','','','',
false ,true,false);
  nb_points_traces:=200;
 for kkk:=0 to nb_points_traces do begin
 mc.croixx(liste_echantillons_entree[indice_distribution-1][0]+(liste_echantillons_entree[indice_distribution-1][nombre_par_echantillon-1]-liste_echantillons_entree[indice_distribution-1][0])*kkk/nb_points_traces,
 Fonction_Distribution(liste_echantillons_entree[indice_distribution-1],nombre_par_echantillon,liste_echantillons_entree[indice_distribution-1][0]+
 (liste_echantillons_entree[indice_distribution-1][nombre_par_echantillon-1]-liste_echantillons_entree[indice_distribution-1][0])*kkk/nb_points_traces),
 2,1,clblue,pmcopy,true);
 mc.croixx(liste_echantillons_entree[indice_distribution-1][0]+(liste_echantillons_entree[indice_distribution-1][nombre_par_echantillon-1]-liste_echantillons_entree[indice_distribution-1][0])*kkk/nb_points_traces,
 Trapeze_integree(liste_distributions[indice_distribution-1].moyenne,liste_distributions[indice_distribution-1].demi_etendue_bas,liste_distributions[indice_distribution-1].demi_etendue_haut,
 liste_echantillons_entree[indice_distribution-1][0]+
 (liste_echantillons_entree[indice_distribution-1][nombre_par_echantillon-1]-liste_echantillons_entree[indice_distribution-1][0])*kkk/nb_points_traces),
 2,1,clred,pmcopy,true);
    end;

 Statistiques_Par_Classe(liste_echantillons_entree[indice_distribution-1],nombre_par_echantillon,nombre_de_classes,
 bornes,effectifs,densites,eff_max,densite_max);


 mc.LimitesEtAxes(@liste_images_densite[indice_distribution-1],bornes[0],bornes[nombre_de_classes],0
         ,densite_max,0,densite_max,liste_images_densite[indice_distribution-1].width,
liste_images_densite[indice_distribution-1].Height, rsDensitDeProb, policetitre, true,
  clwhite, true, 1, clblack,
true,1,4,clblue,policegraduation, true,false,1,clblue,
clblack,'x','f(x)','','','','',
false ,true,false);
 for kkk:=1 to nombre_de_classes do
 mc.MonRectangle(bornes[kkk-1],0,bornes[kkk],densites[kkk-1],clblue,true);
 for kkk:=0 to nb_points_traces do
 mc.croixx(liste_echantillons_entree[indice_distribution-1][0]+(liste_echantillons_entree[indice_distribution-1][nombre_par_echantillon-1]-liste_echantillons_entree[indice_distribution-1][0])*kkk/nb_points_traces,
 Trapeze_densite(liste_distributions[indice_distribution-1].moyenne,liste_distributions[indice_distribution-1].demi_etendue_bas,liste_distributions[indice_distribution-1].demi_etendue_haut,
 liste_echantillons_entree[indice_distribution-1][0]+
 (liste_echantillons_entree[indice_distribution-1][nombre_par_echantillon-1]-liste_echantillons_entree[indice_distribution-1][0])*kkk/nb_points_traces),
 2,1,clred,pmcopy,true);

   end;
    {fin distrib de type trapeze}


    {distrib de type derivee d'arcsin}
 if combobox1.ItemIndex=5 then begin
 liste_distributions[indice_distribution-1].tyty:=d_arcsin;



  liste_distributions[indice_distribution-1].nom_variable:=saisie_dune_grandeur.Edit_arcsin_moyenne.text;
   liste_distributions[indice_distribution-1].moyenne:=0;




  try
  r:=strtofloat(saisie_dune_grandeur.Edit_arcsin_demi_etendue.text);
  except
    application.messagebox(pchar(rsValeurDeLaDe), pchar
      (rsAttention2), mb_ok);
    self.ModalResult:=mrnone;
    exit;
    end;
  if r=0 then begin
  application.messagebox(pchar(rsValeurDeLInc17), pchar(rsAttention2), mb_ok);
    self.ModalResult:=mrnone;
    exit;
    end;
  liste_distributions[indice_distribution-1].demi_etendue:=abs(r);
  liste_distributions[indice_distribution-1].incertitude_type:=liste_distributions[indice_distribution-1].demi_etendue/sqrt(2);





       screen.Cursor:=crhourglass;
    Genere_Derivee_D_Arcsinus(liste_echantillons_entree[indice_distribution-1],nombre_par_echantillon,  liste_distributions[indice_distribution-1].moyenne,
 liste_distributions[indice_distribution-1].demi_etendue);
    Copie_Distribution(liste_echantillons_entree[indice_distribution-1],copie_liste_echantillons_entree[indice_distribution-1],nombre_par_echantillon);
 Tri_Rapide(liste_echantillons_entree[indice_distribution-1],nombre_par_echantillon);
 Decale_Doublons(liste_echantillons_entree[indice_distribution-1],nombre_par_echantillon);
  mc.LimitesEtAxes(@liste_images_integre[indice_distribution-1],liste_echantillons_entree[indice_distribution-1][0],liste_echantillons_entree[indice_distribution-1][nombre_par_echantillon-1],0
         ,1,0,1,liste_images_integre[indice_distribution-1].width,
liste_images_integre[indice_distribution-1].Height, rsFonctionDeDi, policetitre, true,
  clwhite, true, 1, clblack,
true,1,4,clblue,policegraduation, true,false,1,clblue,
clblack,'x','f(x)','','','','',
false ,true,false);
  nb_points_traces:=200;
 for kkk:=0 to nb_points_traces do begin
 mc.croixx(liste_echantillons_entree[indice_distribution-1][0]+(liste_echantillons_entree[indice_distribution-1][nombre_par_echantillon-1]-liste_echantillons_entree[indice_distribution-1][0])*kkk/nb_points_traces,
 Fonction_Distribution(liste_echantillons_entree[indice_distribution-1],nombre_par_echantillon,liste_echantillons_entree[indice_distribution-1][0]+
 (liste_echantillons_entree[indice_distribution-1][nombre_par_echantillon-1]-liste_echantillons_entree[indice_distribution-1][0])*kkk/nb_points_traces),
 2,1,clblue,pmcopy,true);
 mc.croixx(liste_echantillons_entree[indice_distribution-1][0]+(liste_echantillons_entree[indice_distribution-1][nombre_par_echantillon-1]-liste_echantillons_entree[indice_distribution-1][0])*kkk/nb_points_traces,
 Derivee_D_Arcsinus_integree(liste_distributions[indice_distribution-1].moyenne,liste_distributions[indice_distribution-1].demi_etendue,
 liste_echantillons_entree[indice_distribution-1][0]+
 (liste_echantillons_entree[indice_distribution-1][nombre_par_echantillon-1]-liste_echantillons_entree[indice_distribution-1][0])*kkk/nb_points_traces),
 2,1,clred,pmcopy,true);
    end;

 Statistiques_Par_Classe(liste_echantillons_entree[indice_distribution-1],nombre_par_echantillon,nombre_de_classes,
 bornes,effectifs,densites,eff_max,densite_max);


 mc.LimitesEtAxes(@liste_images_densite[indice_distribution-1],bornes[0],bornes[nombre_de_classes],0
         ,densite_max,0,densite_max,liste_images_densite[indice_distribution-1].width,
liste_images_densite[indice_distribution-1].Height, rsDensitDeProb, policetitre, true,
  clwhite, true, 1, clblack,
true,1,4,clblue,policegraduation, true,false,1,clblue,
clblack,'x','f(x)','','','','',
false ,true,false);
 for kkk:=1 to nombre_de_classes do
 mc.MonRectangle(bornes[kkk-1],0,bornes[kkk],densites[kkk-1],clblue,true);
 for kkk:=0 to nb_points_traces do
 mc.croixx(liste_echantillons_entree[indice_distribution-1][0]+(liste_echantillons_entree[indice_distribution-1][nombre_par_echantillon-1]-liste_echantillons_entree[indice_distribution-1][0])*kkk/nb_points_traces,
 Derivee_D_Arcsinus_densite(liste_distributions[indice_distribution-1].moyenne,liste_distributions[indice_distribution-1].demi_etendue,
 liste_echantillons_entree[indice_distribution-1][0]+
 (liste_echantillons_entree[indice_distribution-1][nombre_par_echantillon-1]-liste_echantillons_entree[indice_distribution-1][0])*kkk/nb_points_traces),
 2,1,clred,pmcopy,true);

   end;
    {fin distrib de type derivee d'arcsin}




 314:
liste_distribution_est_traitee[indice_distribution-1]:=true;
  screen.Cursor:=crdefault;


end;

procedure Tsaisie_dune_grandeur.ComboBox1Change(Sender: TObject);
begin


 case   ComboBox1.ItemIndex of

 0: begin
   Panel_normale.Enabled:=false;
   Panel_normale.visible:=false;
   panel_student.Left:=10;
      panel_student.Top:=label2.top+label2.height+20;
   Panel_student.Enabled:=true;
   Panel_student.visible:=true;
    Panel_rectangulaire.Enabled:=false;
   Panel_rectangulaire.visible:=false;
    Panel_triangulaire.Enabled:=false;
   Panel_triangulaire.visible:=false;
    Panel_trapeze.Enabled:=false;
   Panel_trapeze.visible:=false;
    Panel_arcsinus.Enabled:=false;
   Panel_arcsinus.visible:=false;
   imageListexplication.GetBitmap(0, Image_explication.Picture.Bitmap);
   end;

 1:begin
    Panel_normale.Enabled:=true;
     Panel_normale.visible:=true;
    Panel_student.Enabled:=false;
    Panel_student.visible:=false;
    panel_normale.Left:=10;
   panel_normale.Top:=label2.top+label2.height+20;
     Panel_rectangulaire.Enabled:=false;
   Panel_rectangulaire.visible:=false;
    Panel_triangulaire.Enabled:=false;
   Panel_triangulaire.visible:=false;
    Panel_trapeze.Enabled:=false;
   Panel_trapeze.visible:=false;
    Panel_arcsinus.Enabled:=false;
   Panel_arcsinus.visible:=false;
    imageListexplication.GetBitmap(1, Image_explication.Picture.Bitmap);
     radiobutton_degre.Checked:=false;
     radiobutton_inc_inc.Checked:=true;
      edit_degre.Text:='';
      edit_inc_inc.Text:='0';
    end;

 2: begin
   Panel_normale.Enabled:=false;
   Panel_normale.visible:=false;
   panel_rectangulaire.Left:=10;
   panel_rectangulaire.Top:=label2.top+label2.height+20;
   Panel_student.Enabled:=false;
   Panel_student.visible:=false;
    Panel_rectangulaire.Enabled:=true;
   Panel_rectangulaire.visible:=true;
    Panel_triangulaire.Enabled:=false;
   Panel_triangulaire.visible:=false;
    Panel_trapeze.Enabled:=false;
   Panel_trapeze.visible:=false;
    Panel_arcsinus.Enabled:=false;
   Panel_arcsinus.visible:=false;
   imageListexplication.GetBitmap(2, Image_explication.Picture.Bitmap);
   radiobutton_degre.Checked:=false;
     radiobutton_inc_inc.Checked:=true;
      edit_degre.Text:='';
      edit_inc_inc.Text:='0';
   end;

 3: begin
   Panel_normale.Enabled:=false;
   Panel_normale.visible:=false;
   panel_triangulaire.Left:=10;
   panel_triangulaire.Top:=label2.top+label2.height+20;
   Panel_student.Enabled:=false;
   Panel_student.visible:=false;
    Panel_rectangulaire.Enabled:=false;
   Panel_rectangulaire.visible:=false;
    Panel_triangulaire.Enabled:=true;
   Panel_triangulaire.visible:=true;
    Panel_trapeze.Enabled:=false;
   Panel_trapeze.visible:=false;
    Panel_arcsinus.Enabled:=false;
   Panel_arcsinus.visible:=false;
   imageListexplication.GetBitmap(3, Image_explication.Picture.Bitmap);
   radiobutton_degre.Checked:=false;
     radiobutton_inc_inc.Checked:=true;
      edit_degre.Text:='';
      edit_inc_inc.Text:='0';
   end;

 4:  begin
   Panel_normale.Enabled:=false;
   Panel_normale.visible:=false;
   panel_trapeze.Left:=10;
   panel_trapeze.Top:=label2.top+label2.height+20;
   Panel_student.Enabled:=false;
   Panel_student.visible:=false;
    Panel_rectangulaire.Enabled:=false;
   Panel_rectangulaire.visible:=false;
    Panel_triangulaire.Enabled:=false;
   Panel_triangulaire.visible:=false;
    Panel_trapeze.Enabled:=true;
   Panel_trapeze.visible:=true;
    Panel_arcsinus.Enabled:=false;
   Panel_arcsinus.visible:=false;
   imageListexplication.GetBitmap(4, Image_explication.Picture.Bitmap);
   radiobutton_degre.Checked:=false;
     radiobutton_inc_inc.Checked:=true;
      edit_degre.Text:='';
      edit_inc_inc.Text:='0';
   end;

 5: begin
   Panel_normale.Enabled:=false;
   Panel_normale.visible:=false;
   panel_arcsinus.Left:=10;
   panel_arcsinus.Top:=label2.top+label2.height+20;
   Panel_student.Enabled:=false;
   Panel_student.visible:=false;
    Panel_rectangulaire.Enabled:=false;
   Panel_rectangulaire.visible:=false;
    Panel_triangulaire.Enabled:=false;
   Panel_triangulaire.visible:=false;
    Panel_trapeze.Enabled:=false;
   Panel_trapeze.visible:=false;
    Panel_arcsinus.Enabled:=true;
   Panel_arcsinus.visible:=true;
   imageListexplication.GetBitmap(5, Image_explication.Picture.Bitmap);
   radiobutton_degre.Checked:=false;
     radiobutton_inc_inc.Checked:=true;
      edit_degre.Text:='';
      edit_inc_inc.Text:='0';
   end;



 end;


end;

procedure Tsaisie_dune_grandeur.FormCreate(Sender: TObject);
var img: TImage;   bmp: TBitmap;
begin
  encreation:=true;

  CAPTION:=rsSaisie_dune_;
LABEL1.CAPTION:=rsLoiDeDensitD;
LABEL2.CAPTION:=rsParamTresDeL;
LABEL3.CAPTION:=rsNom;
RADIOBUTTON_NORMALE_INCERTITUDE_TYPE.CAPTION:=rsIncertitudeT2;
RADIOBUTTON_NORMALE_INCERTITUDE_ELARGIE.CAPTION:=rsIncertitudeL2;
LABEL4.CAPTION:=rsAuTauxDe;
LABEL8.CAPTION:=rs2;
LABEL10.CAPTION:=rsEtAuChoix;
LABEL12.CAPTION:=rsNom;
LABEL13.CAPTION:=rsEtAuChoix;
RADIOBUTTON_RECTANGULAIRE_INCERTITUDE_TYPE.CAPTION:=rsIncertitudeT2;
RADIOBUTTON_RECTANGULAIRE_DEMI_ETENDUE.CAPTION:=rsDemiTendue;
PANEL2.CAPTION:=rsPanel2;
LABEL14.CAPTION:=rsNom;
LABEL15.CAPTION:=rsEtAuChoix;
RADIOBUTTON_TRIANGULAIRE_INCERTITUDE_TYPE.CAPTION:=rsIncertitudeT2;
RADIOBUTTON_TRIANGULAIRE_DEMI_ETENDUE.CAPTION:=rsDemiTendue;
LABEL19.CAPTION:=rsDemiTendueLa;
LABEL20.CAPTION:=rsDemiTendueAu;
LABEL21.CAPTION:=rsIncertitudeT3;
LABEL22.CAPTION:=rsNom;
LABEL18.CAPTION:=rsNom;
LABEL23.CAPTION:=rsDemiTendue;
LABEL24.CAPTION:=rsIncertitudeT3;
BITBTN1.CAPTION:=rsValiderEtGNR;
BITBTN2.CAPTION:=rsAnnuler;
RADIOBUTTON_TYPE_A.CAPTION:=rsTypeA;
RADIOBUTTON_TYPE_B.CAPTION:=rsTypeB;
LABEL25.CAPTION:=rsTypeDValuati;
LABEL28.CAPTION:=rsParamTreSupp;
LABEL29.CAPTION:=Format(rsDansLeCasDUn, [lineending, lineending, lineending,
  lineending, lineending, lineending]);
RADIOBUTTON_DEGRE.CAPTION:=rsDegrDeLibert2;
RADIOBUTTON_INC_INC.CAPTION:=rsIncRelativeS;
EDIT_INC_INC.TEXT:=rs0;
LABEL30.CAPTION:=rs2;
LABEL31.CAPTION:=Format(rsSiVousNEnSav, [lineending, lineending]);
LABEL6.CAPTION:=rsNombreDeDegr;
LABEL5.CAPTION:=rsNom;
RADIOBUTTON_STUDENT_ECART_TYPE_ECHANTIONNAL.CAPTION:=rsEcartTypeCha2;
RADIOBUTTON_STUDENT_ECART_TYPE_MOYENNE.CAPTION:=rsEcartTypeDeL;
RADIOBUTTON_STUDENT_INCERTITUDE_ELARGIE.CAPTION:=rsIncertitudeL2;
LABEL7.CAPTION:=rsAuTauxDe;
LABEL9.CAPTION:=rsCEstLIncerti;
LABEL11.CAPTION:=rsEtAuChoix;
LABEL16.CAPTION:=rsNombreDeMesu;
LABEL17.CAPTION:=rs2;
SPEEDBUTTON1.HINT:=rsPermetDeCalc;
SPEEDBUTTON1.CAPTION:=rsSaisieDesNMe;
STATICTEXT1.CAPTION:=rsOuAlorsSaisi;
COMBOBOX1.TEXT:=rsStudent;
 combobox1.Items.Clear;
 combobox1.Items.Add(rsStudent);
 combobox1.Items.Add(rsNormale);
 combobox1.Items.Add(rsRectangulair);
 combobox1.Items.Add(rsTriangulaire);
 combobox1.Items.Add(rsTrapezoDale);
 combobox1.Items.Add(rsDRivEDArcsin2);













  panel_student.Left:=10;
   panel_student.Top:=label2.top+label2.height+20;
    Panel_student.Enabled:=true;
    Panel_student.Visible:=true;
    Panel_normale.Enabled:=false;
    Panel_normale.Visible:=false;
    Panel_rectangulaire.Enabled:=false;
    Panel_rectangulaire.Visible:=false;
    Panel_triangulaire.Enabled:=false;
    Panel_triangulaire.Visible:=false;
    Panel_trapeze.Enabled:=false;
    Panel_trapeze.Visible:=false;
    Panel_arcsinus.Enabled:=false;
    Panel_arcsinus.Visible:=false;
    RadioButton_student_ecart_type_echantionnal.Checked:=true;
     Edit_student_ecart_type_echantionnal.Enabled:=true;
     Edit_student_ecart_type_moyenne.Enabled:=false;
     Edit_student_incertitude_elargie.Enabled:=false;
     Edit_student_pourcentage.Enabled:=false;

     img := TImage.Create(nil);
     bmp := TBitmap.Create;

     img.Picture.LoadFromFile(UTF8ToSys(repertoire_images+'loi_1_student_1.'+fallbacklang+'.png'));
      bmp.Assign(img.Picture.Bitmap);
     ImageListexplication.AddMasked(bmp,clblue);

     img.Picture.LoadFromFile(UTF8ToSys(repertoire_images+'loi_2_normale_2.'+fallbacklang+'.png'));
      bmp.Assign(img.Picture.Bitmap);
     ImageListexplication.AddMasked(bmp,clblue);

     img.Picture.LoadFromFile(UTF8ToSys(repertoire_images+'loi_3_rectangle_3.'+fallbacklang+'.png'));
      bmp.Assign(img.Picture.Bitmap);
     ImageListexplication.AddMasked(bmp,clblue);

     img.Picture.LoadFromFile(UTF8ToSys(repertoire_images+'loi_4_triangle_4.'+fallbacklang+'.png'));
      bmp.Assign(img.Picture.Bitmap);
     ImageListexplication.AddMasked(bmp,clblue);

     img.Picture.LoadFromFile(UTF8ToSys(repertoire_images+'loi_5_trapeze_5.'+fallbacklang+'.png'));
      bmp.Assign(img.Picture.Bitmap);
     ImageListexplication.AddMasked(bmp,clblue);

     img.Picture.LoadFromFile(UTF8ToSys(repertoire_images+'loi_6_arcsin6.'+fallbacklang+'.png'));
      bmp.Assign(img.Picture.Bitmap);
     ImageListexplication.AddMasked(bmp,clblue);


     bmp.free;
end;

procedure Tsaisie_dune_grandeur.FormShow(Sender: TObject);
begin
   if encreation then begin scalefont(self); encreation:=false; end;
end;







procedure Tsaisie_dune_grandeur.RadioButton_degreChange(Sender: TObject);
begin
 if   RadioButton_degre.Checked then begin
  edit_inc_inc.Enabled:=false;
  edit_degre.Enabled:=true;

  end;
end;

procedure Tsaisie_dune_grandeur.RadioButton_inc_incChange(Sender: TObject);
begin
  if   RadioButton_inc_inc.Checked then begin
  edit_inc_inc.Enabled:=true;
  edit_degre.Enabled:=false;

  end;
end;

procedure Tsaisie_dune_grandeur.RadioButton_normale_incertitude_elargieChange(
  Sender: TObject);
begin
   if RadioButton_normale_incertitude_elargie.Checked then begin
     edit_normale_incertitude_type.Enabled:=false;
      edit_normale_incertitude_elargie.Enabled:=true;
      edit_normale_pourcentage.Enabled:=true;
    end;
end;

procedure Tsaisie_dune_grandeur.RadioButton_normale_incertitude_typeChange(
  Sender: TObject);
begin
 if RadioButton_normale_incertitude_type.Checked then begin
  edit_normale_incertitude_type.Enabled:=true;
   edit_normale_incertitude_elargie.Enabled:=false;
   edit_normale_pourcentage.Enabled:=false;
 end;


end;

procedure Tsaisie_dune_grandeur.RadioButton_rectangulaire_demi_etendueChange(
  Sender: TObject);
begin
  if RadioButton_rectangulaire_demi_etendue.Checked then begin
   edit_rectangulaire_incertitude_type.Enabled:=false;
   edit_rectangulaire_demi_etendue.Enabled:=true;

   end;
end;

procedure Tsaisie_dune_grandeur.RadioButton_rectangulaire_incertitude_typeChange
  (Sender: TObject);
begin
  if RadioButton_rectangulaire_incertitude_type.Checked then begin
   edit_rectangulaire_incertitude_type.Enabled:=true;
   edit_rectangulaire_demi_etendue.Enabled:=false;

   end;
end;

procedure Tsaisie_dune_grandeur.RadioButton_student_ecart_type_echantionnalChange
  (Sender: TObject);
begin
 if RadioButton_student_ecart_type_echantionnal.Checked then begin
  edit_student_ecart_type_echantionnal.Enabled:=true;
  edit_student_ecart_type_moyenne.Enabled:=false;
   edit_student_incertitude_elargie.Enabled:=false;
   edit_student_pourcentage.Enabled:=false;
  end;;
end;

procedure Tsaisie_dune_grandeur.RadioButton_student_ecart_type_moyenneChange(
  Sender: TObject);
begin
 if RadioButton_student_ecart_type_moyenne.Checked then begin
  edit_student_ecart_type_echantionnal.Enabled:=false;
  edit_student_ecart_type_moyenne.Enabled:=true;
   edit_student_incertitude_elargie.Enabled:=false;
   edit_student_pourcentage.Enabled:=false;
  end;;
end;

procedure Tsaisie_dune_grandeur.RadioButton_student_incertitude_elargieChange(
  Sender: TObject);
begin
  if RadioButton_student_incertitude_elargie.Checked then begin
  edit_student_ecart_type_echantionnal.Enabled:=false;
  edit_student_ecart_type_moyenne.Enabled:=false;
   edit_student_incertitude_elargie.Enabled:=true;
   edit_student_pourcentage.Enabled:=true;
  end;;
end;

procedure Tsaisie_dune_grandeur.RadioButton_triangulaire_demi_etendueChange(
  Sender: TObject);
begin
  if RadioButton_triangulaire_demi_etendue.Checked then begin
    edit_triangulaire_incertitude_type.Enabled:=false;
    edit_triangulaire_demi_etendue.Enabled:=true;

    end;
end;

procedure Tsaisie_dune_grandeur.RadioButton_triangulaire_incertitude_typeChange(
  Sender: TObject);
begin
  if RadioButton_triangulaire_incertitude_type.Checked then begin
   edit_triangulaire_incertitude_type.Enabled:=true;
   edit_triangulaire_demi_etendue.Enabled:=false;

   end;
end;

procedure Tsaisie_dune_grandeur.SpeedButton1Click(Sender: TObject);
var repmode:integer;
begin
  with Form_aidecalcul do begin
 if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
end;
  repmode:=Form_aidecalcul.ShowModal;
  if ((repmode=mrok) and (_nombre_mesures>1)) then
     begin

    Edit_student_nombre_degre_de_liberte.Text:=inttostr(_nombre_mesures-1);
    Edit_student_ecart_type_echantionnal.Text:=floattostr(_ecart_type);
    liste_distributions[indice_distribution-1].moyenne:=_moyenne;
     liste_student_a_ete_modifiee:=true;
        RadioButton_student_ecart_type_echantionnal.Checked:=true;
     RadioButton_student_ecart_type_moyenne.Checked:=false;
     RadioButton_student_incertitude_elargie.Checked:=false;
     end;
end;

initialization
  {$I unit_saisie_proprietes_dune_grandeur.lrs}

end.

